//+------------------------------------------------------------------+
//|                                                    bbsqueeze.mq4 |
//|                Copyright  2005, Nick Bilak, beluck[AT]gmail.com |
//|           enhanced a little bit by CJ Rivas, carlos[AT]vealo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#property link      "http://metatrader.50webs.com/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Blue
#property indicator_color2  Lime
#property indicator_minimum -0.1
#property indicator_maximum  0.1



//---- input parameters
extern int       bolPrd=20;
extern double    bolDev=2.0;
extern int       keltPrd=20;
extern double    keltFactor=1.5;

//---- buffers

double upK[];
double loK[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   SetIndexStyle(0,DRAW_ARROW,EMPTY,2);
   SetIndexBuffer(0,upK);
   SetIndexArrow(0,159);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,2);
   SetIndexBuffer(1,loK);
   SetIndexArrow(1,159);
   IndicatorShortName("SQ2.01 Reduced Code");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
       int limit=MathMin(Bars-counted_bars,Bars-1);
   
   for (int shift=limit; shift>=0; shift--)   
   {      
		double diff = iATR(NULL,0,keltPrd,1)*keltFactor;
		    if (diff==0) continue;
		double std  = iStdDev(NULL,0,bolPrd,MODE_SMA,0,PRICE_CLOSE,1);
		double bbs  = bolDev * std / diff;
         if(bbs<1) 
               { upK[shift]=0; loK[shift]=EMPTY_VALUE; }
         else  { loK[shift]=0; upK[shift]=EMPTY_VALUE; }
   }   
   return(0);
}

